/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Thu Jul 18 14:58:17 CDT 2002
    copyright            : (C) 2002 by Renchi Raju
    email                : renchi@green.tam.uiuc.edu
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "digikamsplash.h"
#include "digikam.h"

static const char *description =
I18N_NOOP("An Image Management Application For KDE");


static KCmdLineOptions options[] =
{
    { 0, 0, 0 }
};

int main(int argc, char *argv[])
{

    KAboutData aboutData( "digikam", I18N_NOOP("Digikam"),
                          VERSION, description, KAboutData::License_GPL,
                          "(c) 2002, Renchi Raju", 0, 0, "renchi@green.tam.uiuc.edu");
    aboutData.addAuthor("Renchi Raju",0, "renchi@green.tam.uiuc.edu");
    KCmdLineArgs::init( argc, argv, &aboutData );
    KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

    KApplication a;

    DigikamSplash *splash = new DigikamSplash();
    splash->show();

    Digikam *digikam = new Digikam();
    a.setMainWidget(digikam);
    digikam->show();

    return a.exec();
}
